// VCSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCSample.h"
#include "VCSampleDlg.h"
#include "VaxVoIP.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CVCSampleDlg dialog

CVCSampleDlg::CVCSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCSampleDlg)
	m_bBusyStatus = FALSE;
	m_bUnavailableStatus = FALSE;
	m_bSpkMute = FALSE;
	m_bMicMute = FALSE;
	m_sSendText = _T("");
	m_nRemotePort = 33550;
	m_nListenPort = 33550;
	m_sIPTo = _T("");
	m_bStartRecording = FALSE;
	m_sWaveFileName = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pVaxVoIP = new CVaxVoIP;
}

void CVCSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCSampleDlg)
	DDX_Control(pDX, IDC_COMBO_IP, m_IPComboBox);
	DDX_Control(pDX, IDC_LIST_TEXT, m_ReceiveTxtListBox);
	DDX_Control(pDX, IDC_SLIDER_MICVOL, m_MicSlider);
	DDX_Control(pDX, IDC_SLIDER_SPKVOL, m_SpkSlider);
	DDX_Check(pDX, IDC_CHECK_BUSY, m_bBusyStatus);
	DDX_Check(pDX, IDC_CHECK_UNAVAILABLE, m_bUnavailableStatus);
	DDX_Check(pDX, IDC_CHECK_SPKMUTE, m_bSpkMute);
	DDX_Check(pDX, IDC_CHECK_MICMUTE, m_bMicMute);
	DDX_Text(pDX, IDC_EDIT_TXT, m_sSendText);
	DDX_Text(pDX, IDC_EDIT_REMOTE_PORT, m_nRemotePort);
	DDX_Text(pDX, IDC_EDIT_LISTEN_PORT, m_nListenPort);
	DDX_CBString(pDX, IDC_COMBO_IP, m_sIPTo);
	DDX_Check(pDX, IDC_CHECK_START_RECORDING, m_bStartRecording);
	DDX_Text(pDX, IDC_EDIT_WAVE_FILE, m_sWaveFileName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CVCSampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_ONLINE, OnButtonOnline)
	ON_BN_CLICKED(IDC_BUTTON_OFFLINE, OnButtonOffline)
	ON_BN_CLICKED(IDC_CHECK_UNAVAILABLE, OnCheckUnavailable)
	ON_BN_CLICKED(IDC_CHECK_BUSY, OnCheckBusy)
	ON_BN_CLICKED(IDC_CHECK_MICMUTE, OnCheckMicmute)
	ON_BN_CLICKED(IDC_CHECK_SPKMUTE, OnCheckSpkmute)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BUTTON_SENDTXT, OnButtonSendtxt)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_RESET_WAVE_BUFFER, OnButtonResetWaveBuffer)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_WAVE_FILE, OnButtonSaveWaveFile)
	ON_BN_CLICKED(IDC_CHECK_START_RECORDING, OnCheckStartRecording)
	ON_BN_CLICKED(IDC_BUTTON_START_CONVERSATION, OnButtonStartConversation)
	ON_BN_CLICKED(IDC_BUTTON_END_CONVERSATION, OnButtonEndConversation)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(IDC_BUTTON_ADD_CONVERSATION, OnButtonAddConversation)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCSampleDlg message handlers

BOOL CVCSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	m_SpkSlider.SetRange(0,10);
	m_MicSlider.SetRange(0,10);
	
	CWnd* pTxRxIconWnd = GetDlgItem(IDC_STATIC_RED);
	pTxRxIconWnd->ShowWindow(SW_HIDE);

	pTxRxIconWnd = GetDlgItem(IDC_STATIC_GREEN);
	pTxRxIconWnd->ShowWindow(SW_HIDE);

	pTxRxIconWnd = GetDlgItem(IDC_STATIC_GB);
	pTxRxIconWnd->ShowWindow(SW_SHOW);

	pTxRxIconWnd = GetDlgItem(IDC_STATIC_RB);
	pTxRxIconWnd->ShowWindow(SW_SHOW);

	SetTimer(0, 500, NULL);
		
	return TRUE;
}


void CVCSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


HCURSOR CVCSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVCSampleDlg::OnDestroy() 
{
	delete m_pVaxVoIP;
	
	CDialog::OnDestroy();
}


void CVCSampleDlg::OnButtonOnline() 
{
	UpdateData();
	
	m_pVaxVoIP->SetLicenceKey("EVALUATE");

	if(!m_pVaxVoIP->Initialize(m_nListenPort))
	{
		m_pVaxVoIP->ErrorMessage();
		return;
	}

	int nVol = m_pVaxVoIP->GetMicVolume();
	
	if(nVol == -1)
	{
		m_pVaxVoIP->ErrorMessage();
		return;
	}

	m_MicSlider.SetPos(nVol/25);

	nVol = m_pVaxVoIP->GetSpkVolume();
	
	if(nVol == -1)
	{
		m_pVaxVoIP->ErrorMessage();
		return;
	}

	m_SpkSlider.SetPos(nVol/25);
	
	MessageBox("You are online now!", "Success", MB_OK|MB_ICONINFORMATION);

}

void CVCSampleDlg::OnButtonOffline() 
{
	m_pVaxVoIP->UnInitialize();
}

void CVCSampleDlg::OnButtonStartConversation() 
{
	UpdateData();
	
	if(!m_pVaxVoIP->Connect(m_sIPTo, m_nRemotePort, 20)) //TimeOut in seconds
	{
		m_pVaxVoIP->ErrorMessage();
	}

	m_IPComboBox.AddString(m_sIPTo);
}

void CVCSampleDlg::OnButtonEndConversation() 
{
	if(!m_pVaxVoIP->Disconnect())
	{
		m_pVaxVoIP->ErrorMessage();
	}

	GetDlgItem(IDC_STATIC_CALLSTATUS)->SetWindowText("");

}

void CVCSampleDlg::OnButtonAddConversation() 
{
	UpdateData();
	
	if(!m_pVaxVoIP->AddInConf(m_sIPTo, m_nRemotePort, 20)) //TimeOut in seconds
	{
		m_pVaxVoIP->ErrorMessage();
	}

	m_IPComboBox.AddString(m_sIPTo);
	
}

void CVCSampleDlg::OnCheckUnavailable() 
{
	UpdateData();
	
	if(m_bUnavailableStatus)
	{
		m_pVaxVoIP->EnableNotAvailableState();
	}
	else
	{
		m_pVaxVoIP->DisableNotAvailableState();
	}
}

void CVCSampleDlg::OnCheckBusy() 
{
	UpdateData();
	
	if(m_bBusyStatus)
	{
		m_pVaxVoIP->EnableBusyState();
	}
	else
	{
		m_pVaxVoIP->DisableBusyState();
	}
}

void CVCSampleDlg::OnCheckMicmute() 
{
	UpdateData();
	m_pVaxVoIP->MuteMic(m_bMicMute);
}

void CVCSampleDlg::OnCheckSpkmute() 
{
	UpdateData();
	m_pVaxVoIP->MuteSpk(m_bSpkMute);
}

void CVCSampleDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if((CSliderCtrl*)pScrollBar == &m_SpkSlider)
	{
		if(TB_THUMBTRACK)
		{
			/***************************************************************
			SetSpkVolume method requires Volume value from 0 to 255 range    
			but the slider range is 0 to 10, so we multiply the slider value 
			to 25 to get the required value to pass to SetSpkVolume method   

							For more detail, please see the method details document
			*****************************************************************/
			
			m_pVaxVoIP->SetSpkVolume(m_SpkSlider.GetPos()	* 25);
		}

	}
	
	
	
	if((CSliderCtrl*)pScrollBar == &m_MicSlider)
	{
		if(TB_THUMBTRACK)
		{
			/***************************************************************
			SetMicVolume method requires Volume value from 0 to 255 range    
			but the slider range is 0 to 10, so we multiply the slider value 
			to 25 to get the required value to pass to SetMicVolume method   

							For more detail, please see the method details document
			*****************************************************************/
			
			m_pVaxVoIP->SetMicVolume(m_MicSlider.GetPos()	* 25);
		}

	}
	
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CVCSampleDlg::OnButtonSendtxt() 
{
	UpdateData();
	
	if(!m_pVaxVoIP->SendTxtMsg(m_sSendText))
	{
		m_pVaxVoIP->ErrorMessage();
	}
	else
	{
		m_ReceiveTxtListBox.AddString("You: " + m_sSendText);
		m_sSendText = "";
		UpdateData(FALSE);
	}
}

void CVCSampleDlg::OnTimer(UINT nIDEvent) 
{
	DWORD dwDataRate = m_pVaxVoIP->GetOutBoundDataRate();
	
	if(dwDataRate == 0)
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_GREEN);
		pWnd->ShowWindow(SW_HIDE);

		pWnd = GetDlgItem(IDC_STATIC_GB);
		pWnd->ShowWindow(SW_SHOW);
	}
	else
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_GREEN);
		pWnd->ShowWindow(SW_SHOW);

		pWnd = GetDlgItem(IDC_STATIC_GB);
		pWnd->ShowWindow(SW_HIDE);
	}
	

	if(dwDataRate == 0)
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_RED);
		pWnd->ShowWindow(SW_HIDE);

		pWnd = GetDlgItem(IDC_STATIC_RB);
		pWnd->ShowWindow(SW_SHOW);
	}
	else
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_RED);
		pWnd->ShowWindow(SW_SHOW);

		pWnd = GetDlgItem(IDC_STATIC_RB);
		pWnd->ShowWindow(SW_HIDE);
	}

	CDialog::OnTimer(nIDEvent);
}



void CVCSampleDlg::OnButtonResetWaveBuffer() 
{
	m_pVaxVoIP->ResetRecording();
}

void CVCSampleDlg::OnButtonSaveWaveFile() 
{
	UpdateData();
	
	if(!m_pVaxVoIP->SaveRecordingToFile(m_sWaveFileName))
		m_pVaxVoIP->ErrorMessage();
	else
		MessageBox("Saved Successfully", "Conversation Saved", MB_OK|MB_ICONINFORMATION);
}

void CVCSampleDlg::OnCheckStartRecording() 
{
	UpdateData();
	
	if(m_bStartRecording)
	{
		if(!m_pVaxVoIP->StartRecording())
			m_pVaxVoIP->ErrorMessage();
	}
	else
	{
		if(!m_pVaxVoIP->StopRecording())
			m_pVaxVoIP->ErrorMessage();
	}
}

